% following part gives you a wavelet called w (ignore it)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

x = -3:0.1:3;

y = sinc(x)';

L = length(y);

h = hamming(L);



w0 = y.*h;



R = xcorr(w0,w0);



d0 = roots (R);       % compute dipoles

d1 = abs(d0);

ID = find(d1>1);

d2 = d0(ID);

dm = -1./d2;

Ld = length(dm);



w = 1; 

for n = 1:Ld               % convolute all dipoles to get minimum phase wavelet

    w = conv(w,[1,dm(n)]); 

end



w = real(w)';



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% half length VS whole length



nw = length(w);

f  = fft(w);  

f2 = f(1:floor(nw/2)+1);

iw  = ifft(f2, nw/2+1);   % half length

iiw = ifft(f);       % whole length



figure(2);clf;

subplot(311);

plot(w);title('original');



subplot(312);

plot(real(iw));title('half length ifft');



subplot(313);

plot(real(iiw));title('whole length ifft');



figure(3);clf;

subplot(311);

plot(w/max(w));title('original (normalized)');



subplot(312);

plot(real(iw)/max(real(iw)));title('half length ifft (normalized)');



subplot(313);

plot(real(iiw)/max(real(iiw)));title('whole length ifft (normalized)');


