#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include <fcntl.h>
#include <assert.h>
#include <string.h>
#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>

#include "gulib.h"
const int PERM = 0644;   // read and write for owner


void EQST::RdWrtList()
{   
// reads Scripts' travel time data and write in ttime_sum_amat format.
 
  int ndat, i, nwritten, fd;
  int opt;
  fstream inFile, outFile;
  char  flname_in[256], flname_out[256];
  char  dumstr[256];
  char ch;
  TempOut tempout;
  
  cout << "input Scripps Data:" << endl;
  cin >> flname_in;
  inFile.open(flname_in, ios::in);
  if(!inFile) {
  	cerr << "Cannot open input file " << flname_in << endl;
  }
  cout << "choose:" << endl;
  cout << "========================================" << endl;
  cout << "1. create binary file for SS or ScS"  << endl;
  cout << "2. create binary file for S  " << endl;
  cout << "enter:" << endl;
  cin >> opt;
  cout << "Output file name:" << endl;
  cin >> flname_out ;
  fd = creat(flname_out, PERM);
  while(inFile.get(ch) && ch != '\n') cout << " ";
  ndat = 0;
  while((inFile >> st >> stlat >> stlon >> year >> month >> date
  >> hour >> min >> sec >> eqlat >> eqlon >> depth >> ttime >> dt >> ellipcorr >> grade >> dist) != NULL) {
     ndat ++;
     if(eqlon >180.0) eqlon -= 360.0;
     if(stlon >180.0) stlon -= 360.0;
//     cout << st << " " << stlat << " " << stlon << " " <<year
//     <<" " << month << " " << date <<" " << hour << " " << min 
//     << " " << sec  << " " << eqlat << " "<< eqlon
//     <<" "<< depth << " " << ttime << " " << dt << " " << ellipcorr
//     << " " << grade << " " << dist << endl;

     Write_TtimeBin(tempout, opt);
     nwritten = write(fd, &tempout, 72);
 cout << tempout.eqname << "  " << tempout.elat << "  " << tempout.elon << "  " << tempout.slat
  << "  " << tempout.slon << "  " << tempout.edep << "  " << 
 tempout.stname << "  " << tempout.stelv << "  " << tempout.ig << endl;
  
  }
  cout << "total data = " << ndat << endl;   
  inFile.close();
  close(fd);
   
}

void EQST::Write_TtimeBin(TempOut &tempout, int opt)
{
  int i, j;
  char ch;

  strcpy(tempout.eqname, "NOTAVAL");
  tempout.elat = eqlat;
  tempout.elon = eqlon;
  tempout.edep = depth;
  tempout.slat = stlat;
  tempout.slon = stlon;
  for(i=0;i<3; i++) {
     tempout.stname[i] = st[i];
  }
  tempout.stelv = 0.0;
  if(grade == 'A') {
      tempout.ig = 1;
  } 
  if(grade == 'B') {
      tempout.ig = 2;
  } 
  if(grade == 'C') {
      tempout.ig = 3;
  } 
  if(grade == 'D') {
      tempout.ig = 4;
  } 
  tempout.res = ttime-dt;
  tempout.crustcor=0.0;
  tempout.evcor=0.0;
  tempout.elipc = ellipcorr;
  if(opt == 2) {  // if S, then set everything to 0
     tempout.elipc = 0.0;
     tempout.res = 0.0;
  }
  tempout.delta = dist;
  tempout.coric = 0.0;
  tempout.spare = 0.0;  
}


void EQST::RdWrtList_Harvard()
{   
// reads Harvard travel time data and write in ttime_sum_amat format.
 
  int ndat, i, nwritten, fd;
  int opt, ngood;
  fstream inFile, outFile;
  char  flname_in[256], flname_out[256];
  char  dumstr[256];
  char ch,event[7];
  char phase[12];
  float slow1, slow2, pntlat, pntlon;
  float corr1, corr2, corr3, corr4, uncert, weight, pred;
  TempOut tempout;
  
  cout << "Input Harvard Data list (ascii):" << endl;
  cin >> flname_in;
  inFile.open(flname_in, ios::in);
  if(!inFile) {
  	cerr << "Cannot open input file " << flname_in << endl;
  }
  cout << "choose :" << endl;
  cout << "------------------------------------" << endl;
  cout << "1. discard grade C data" << endl;
  cout << "2. discard grade D data" << endl;
  cout << "3. discard grade C and D data" << endl;
  cout << "4. keep all data" << endl;
  cout << "enter:" << endl;
  cin >> opt;
  cout << "Output file name:" << endl;
  cin >> flname_out ;
  fd = creat(flname_out, PERM);
  while(inFile.get(ch) && ch != '\n') cout << " ";
  cout << endl;
  ndat = 0;
  ngood=0;
  while((inFile >> event >> st >> eqlat >> eqlon >> depth >> stlat >> stlon 
	>> phase >> grade >> slow1 >> slow2 >> dist >> pntlat >> pntlon
	>> ttime >> corr1 >> corr2 >> corr3 >> corr4 >> uncert >> weight >> pred ) != NULL) {
     ndat ++;
     if(eqlon >180.0) eqlon -= 360.0;
     if(stlon >180.0) stlon -= 360.0;
//     cout << event << "  " << st << " "<< stlat << " " << stlon << " " << eqlat << " "<< eqlon
//    <<" "<< depth << " " << ttime << " " << " " << grade << " " << dist << endl;
     ttime = ttime-corr1+corr2-corr3+corr4;
     Write_TtimeBin_Harvard(tempout);
     if(opt==1 && tempout.ig==3) continue;
     if(opt==2 && tempout.ig==4) continue;
     if(opt==3 && (tempout.ig==3 || tempout.ig==4)) continue;
     ngood ++;
     nwritten = write(fd, &tempout, 72);
     if(ndat<20) {
 	cout << tempout.eqname << "  "<< tempout.elat << "  " << tempout.elon << "  " << tempout.slat
  	<< "  " << tempout.slon << "  " << tempout.edep << "  " 
	<< tempout.res << "  " << tempout.ig <<" dist =" << tempout.delta << endl;
     }
  
  }
  cout << "total data = " << ndat  << "   good data=" << ngood << endl;   
  inFile.close();
  close(fd);
   
}

void EQST::Write_TtimeBin_Harvard(TempOut &tempout)
{
  int i, j;
  char ch;

  strcpy(tempout.eqname, "XXXXXXX");
  tempout.elat = eqlat;
  tempout.elon = eqlon;
  tempout.edep = depth;
  tempout.slat = stlat;
  tempout.slon = stlon;
  for(i=0;i<3; i++) {
     tempout.stname[i] = st[i];
  }
  tempout.stelv = 0.0;
  if(grade == 'A') {
      tempout.ig = 1;
  } 
  if(grade == 'B') {
      tempout.ig = 2;
  } 
  if(grade == 'C') {
      tempout.ig = 3;
  } 
  if(grade == 'D') {
      tempout.ig = 4;
  } 
  tempout.res = ttime;
  tempout.ttime=0.0;
  tempout.elipc = 0.0;
  tempout.crustcor=0.0;
  tempout.evcor=0.0;
  tempout.delta = dist;
  tempout.coric = 0.0;
  tempout.spare = 0.0;  
}

EQST::~EQST()
{
}

