const float PI = 3.14159265;


typedef struct TempOut{	// structure defined for reading only
	char  eqname[8];	// earthquake name
	float elat;		// summary earthquake latitude (in degree)
	float elon;		// longitude
	float edep;		// earthquake depth
	char  stname[4];	// station name
	float slat;		// summary station latitude (in degree)
	float slon;		// summary station longitude (in degree)
	float stelv;	       // station elevation (in km)
	float res;		// observed residual
	int   ig;		// grade
	float ttime;	       // total travel time
	float elipc;    	// ellipcity correction
	float crustcor;	// crustal correction
	float evcor;	       // station elevation correction
	float delta;	       // epicentral distance
	float coric;	       // innor core correction
	float spare;
} TempOut;

class EQST{
public:
	~EQST();
	void RdWrtList();
	void RdWrtList_Harvard();
	void Write_TtimeBin_Harvard(TempOut &);
	void Write_TtimeBin(TempOut &, int);
protected:
	int year, month, date;
	int hour, min;
	float sec;
	float stlat, stlon;
	float eqlat, eqlon;
	float depth;
	float dist;
	float ttime;
	float dt;
	float ellipcorr;
	char grade;
	char st[4];
};
