#ifndef WSCONSHEADER
#define WSCONSHEADER

const	int	UNDEFINED=0;	// region definition
const	int	WHOLEMANTLE=1;
const	int	UPPERMANTLE=2;
const	int	LOWERMANTLE=3;
const	int	UPLOWMANTLE=4;


const	float	RADIUS	=(float)6371.0;
const float	DEPMOHO	=(float)24.4;
const	float	DEP220	=(float)220.0;
const	float	DEP400	=(float)400.0;
const	float	DEP670	=(float)670.0;
const	float	DEPCMB	=(float)2891.04;
const	float	DEPICB	=(float)5149.51;
const	float	RMOHO		=RADIUS-DEPMOHO;
const	float	R670		=RADIUS-DEP670;
const	float	RCMB		=RADIUS-DEPCMB;

const int	TRUE=1;
const int	FALSE=0;
const int	PERMS=0666;
const float	PI		=(float)3.14159265;
const float	RAD		=(float)0.017453292519943;	// (pi/180.0)
const float	HPI		=(float)0.5*PI;			// 0.5*pi
const float	TWOPI		=(float)2.0*PI;			// 2.0*pi


//
// function types
//
const	int	NORADFUN=0;	//no radial functions
const	int	LEGENDRE=1;
const	int	CHEBYSHEV=2;
const	int	SHELL=3;
const	int	BSPLINE=4;
const	int	HARMONICS=5;
const	int	OTHERFUNC=6;
//
// model formats
//
const	int	HVDHARM=1;
const	int	HVDBS=2;
const	int	CHARM=3;	// complext spherical harmonic

const	int	WHOLE_EARTH=0;	// read model options
const	int	REGIONAL=1;
const	int	WERECOM=2;

const	int	MINORARC=1;
const	int	MAJORARC=2;
const	int	GREATCIRCLE=3;


#endif
