/*
 * premtt.c
 */
#include <stdio.h>
#include <math.h>
#include <sgtty.h>
#include <signal.h>
#include <string.h>
#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>
#include "/scratch/troika23/gu/sulib/wslib.h"
#include "premtt.h"
#define   PRINT  0
#define   KERNEL 1

void calc_premtt_kernel(dep,rayname,dmin,ifkernel,iferr, premtt)
double dep;
double dmin;
char  *rayname;
int   ifkernel;
double *premtt;
int   *iferr;
{
DECKPREM  prem;
RAY       ray;
double dtdh,delta,ttime;
double p1,x1,p2,x2,p,xacc,dmax;
double ttime1,ttime2,delta1,delta2,dtdh1,dtdh2;
double d,ddelta,dp,**sum;
float del,tt,slow,sdtdh;
int i,k,l,i1,i2,ibc,ierr,diff,nn,kmax,lmax,fd,iflag,region,choice;
int io1,io2,iflag1,iflag2;
char *rname,fname[132],fname1[132],fname2[132];
FILE *fp;
/*
extern writekin();
*/

 *iferr=0;
 io1=9;
 io2=10;

    GetSphModel(&prem);            /* read in the earth model */
/*    
    printf("input source depth:");
    scanf("%lf",&dep);
    printf("\nsource depth=%lf\n",dep);
*/
    CheckDepth(prem, &dep);
    SplitModel(&prem,dep);         /* add 2 layers due to source */
    PrintPrem(prem);               /* print model                */    
    GetRayName(&ray,prem,rayname);         /* read phase name            */
    GetRayPara(&ray,prem,ifkernel);         /* get ray parameters         */
    GetRayBranch(&ray,prem);       /* bracket into different branches */

    rname=ray.rname;
/*    
    printf("There are%3d different branche(s) for the phase.\n",ray.nb);
    printf("____________________________________________");
    printf("__________________________________________\n");
    printf("Branch delta1   ttime1    p1     dtdh1  --->");
    printf(" delta2   ttime2    p2     dtdh2  maxdep\n");  
*/
    for(i=1;i<=ray.nb;i++){
      p1=ray.para[i][2];
      if(!strncmp(rname,"PKP",3))p1-=0.01;
      IntgrateDelTim(ray,p1,prem,&ttime1,&delta1,&ierr);
      if(ierr)errormessage(18);
      p2=ray.para[i][1];
      IntgrateDelTim(ray,p2,prem,&ttime2,&delta2,&ierr);
      if(ierr)errormessage(18);
      if(delta1>delta2){            /* arrange so that delta1<delta2 */
         DSwap(&delta1,&delta2);
         DSwap(&p1,&p2);
         DSwap(&ttime1,&ttime2);
      }
      dtdh1=CalDtDh(prem,ray,p1);
      dtdh2=CalDtDh(prem,ray,p2);
/*            
      printf("%4d %8.2f %8.2f %7.4f %7.3f",
              i,delta1/RAD,ttime1,p1*RAD,dtdh1);
      printf("     %8.2f %8.2f %7.4f %7.3f %8.2f\n",
             delta2/RAD,ttime2,p2*RAD,dtdh2,RADIUS-prem.r[ray.lastlay[i]]);
*/
    }


 /* always uses branch 1 in this case */
    ibc=1; 

    if(!strncmp(rname,"PKP",3)||!strncmp(rname,"pPKP",4)){     /* PKP needs special treatment */
        printf("\nPKP phase has multiple branches.\n");
        
        p =p1;                   /* find branch point */
        d =delta1;
        dp=10.0;
        while(fabs(dp)>0.001){   /* loop until converge */
           p+=dp;
           IntgrateDelTim(ray,p,prem,&ttime,&delta,&ierr);
           if(delta>=d)dp=-0.5*dp;
           d=delta;
        }
/*        
        printf("Branch     p    delta1   time1         p   delta2   time2\n");
        printf("  AB %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f\n",
            p*RAD,d/RAD,ttime,p2*RAD,delta2/RAD,ttime2);
        printf("  BC %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f\n",
            p*RAD,d/RAD,ttime,p1*RAD,delta1/RAD,ttime1);
        
       printf("Choose a branch (AB=1, BC=2):\n");
       scanf("%d",&ibc);
*/
       if      (ibc==1){           /* AB branch */
            p1=p;
            delta1=d;
            ttime1=ttime;
       }else if(ibc==2){
            p2=p1;
            delta2=delta1;
            ttime2=ttime1;
            p1=p;
            delta1=d;
            ttime1=ttime;
       }else errormessage(19);

       dtdh1=CalDtDh(prem,ray,p1);
       dtdh2=CalDtDh(prem,ray,p2);
    }
    
    ibc=1;
    if(ray.nb>1){            /* if there are more than one branch, choose one */
/*
       printf("Choose a branch:\n");
       scanf("%d",&ibc);
*/
       p1=ray.para[ibc][2];
       IntgrateDelTim(ray,p1,prem,&ttime1,&delta1,&ierr);
       p2=ray.para[ibc][1];
       IntgrateDelTim(ray,p2,prem,&ttime2,&delta2,&ierr);
       if(delta1>delta2){
         DSwap(&delta1,&delta2);
         DSwap(&p1,&p2);
         DSwap(&ttime1,&ttime2);
       }
       dtdh1=CalDtDh(prem,ray,p1);
       dtdh2=CalDtDh(prem,ray,p2);
    }
/*
    printf("%4d %8.2f %8.2f %7.4f %7.3f",
              ibc,delta1/RAD,ttime1,p1*RAD,dtdh1);
    printf("     %8.2f %8.2f %7.4f %7.3f %8.2f\n",
             delta2/RAD,ttime2,p2*RAD,dtdh2,RADIUS-prem.r[ray.lastlay[ibc]]);
    printf("\n\nstandard distance range:  %lf  to  %lf\n\n",delta1/RAD, 
	delta2/RAD); 
    printf("input deltamin deltamax ddelta (in degrees):\n");
    dmin*=RAD;
    dmax*=RAD;
    ddelta*=RAD;
*/
    dmin *= RAD;
    dmax = dmin;
    ddelta = RAD;
    
    if(dmin<delta1){
       printf("delta too small, ignore...\n");
       *iferr=1;
       return;
       printf("The lower bound of the epicentral distance inputed\n");
       printf("is less than the minimum value. \n");
       printf("The lower bound is automatically set to %12.4f\n",delta1/RAD);
       dmin=delta1;
    }
    
    if(dmax>delta2){
       printf("diffracted, ignore..\n");
       *iferr=1;
       return;
       printf("diffracted P or S? 0 - no, 1 - yes\n");
       scanf("%d",&diff);
       if(diff==0)dmax=delta2;
    }
 /*   
    printf("File for  travel-time table:");
    scanf("%s",fname);
    fp=fopen(fname,"a");
    
    fprintf(fp,"%12.4f\n",dep);
    printf("file name:%s\n",fname);
*/
    if(ifkernel>0) {
    	ChooseTabRad(&kmax,&lmax,&region,&choice); /* table type and radial function */ 

    	if(choice==5){
       	printf("output file for mu/rho kernel table:");
       	scanf("%s",fname1);
       	printf("output file for kappa/rho kernel table:");
       	scanf("%s",fname2);
    	}else{
       		printf("output file for kIn kernel table:");
       		scanf("%s",fname1);
    	}

        
    	sum= dmatrix(0,kmax,1,2*lmax+1);
    	iflag=1;                        /* to open output file */
    	iflag1=1;				/* to open another output file for kappa mu */
    	iflag2=1;				/* to open another output file for kappa mu */
    }
    xacc=XACC;                      /* accuracy            */
    for(d=dmin;d<=dmax+0.0001;d+=ddelta){
        if(fabs(d-59.0*RAD)<0.001){
           diff=diff;
        }
        if(diff==1 && d>delta2){
           p=p2;
           dtdh=dtdh2;
           ttime=ttime2+(d-delta2)*p;
           delta=d;
	   if(ifkernel>0) {    
           	CalThetaR(p,prem,&ray,&ierr);
           	RayPath(p,prem,ray,&ierr,&nn,diff,d-delta2,region);
	   }
        }else{
           FindPara(prem,p1,delta1,p2,delta2,xacc,d,&p,&delta,&ierr);
           IntgrateDelTim(ray,p,prem,&ttime,&delta,&ierr);
	   if(ifkernel>0) {   
           	CalThetaR(p,prem,&ray,&ierr);
           	RayPath(p,prem,ray,&ierr,&nn,diff,0.0,region);
           }
           dtdh=CalDtDh(prem,ray,p);
           delta=d;
        }
        if(ifkernel>0){ 
      		del=(float)delta/RAD;
      		tt=(float)ttime;
      		slow=(float)p*RAD;
      		sdtdh=(float)dtdh;
      		if(region==MOHOSURF){
        	 	KINintMoho(1,nn,ray,sum,lmax);
/*
         		writekin_(&io1,fname1,&kmax,&lmax,&sum[0][1],&iflag,&del,&tt,&slow,&sdtdh); 
*/
      		}else{
        	   if(choice==5){
           		KINint(1,nn,ray,sum,kmax,lmax,region,MUKER_P);
/*
           		writekin_(&io1,fname1,&kmax,&lmax,&sum[0][1],&iflag1,&del,&tt,&slow,&sdtdh); 
*/
           		KINint(1,nn,ray,sum,kmax,lmax,region,KAPPAKER_P);
/*
           		writekin_(&io2,fname2,&kmax,&lmax,&sum[0][1],&iflag2,&del,&tt,&slow,&sdtdh); 
*/
        	   }else{
           		KINint(1,nn,ray,sum,kmax,lmax,region,OTHERKER);
/*
           		writekin_(&io1,fname1,&kmax,&lmax,&sum[0][1],&iflag,&del,&tt,&slow,&sdtdh); 
*/
        	   }
      		}
      
        }
/*
      	printf("%8.2f %8.2f %8.3f %8.4f\n",delta/RAD,ttime,p*RAD,dtdh);
*/
	*premtt=ttime;
/*
      	fprintf(fp,"%7.2f %8.2f %6.3f %8.4f\n",delta/RAD,ttime,p*RAD,dtdh);
*/
    }
   
    if(ifkernel>0){
   	iflag=2;                 /* close file */
   	iflag1=2;                                  /* close file */
   	iflag2=2;                                  /* close file */
   	if(choice==5){
/*
      		writekin_(&io1,fname1,&kmax,&lmax,&sum[0][1],&iflag1,&del,&tt,&slow,&sdtdh);
      		writekin_(&io2,fname2,&kmax,&lmax,&sum[0][1],&iflag2,&del,&tt,&slow,&sdtdh);
*/
   	}else{
/*
      		writekin_(&io1,fname1,&kmax,&lmax,&sum[0][1],&iflag,&del,&tt,&slow,&sdtdh);
*/
   	}
   	free_dmatrix(sum,0,kmax,1,2*lmax+1);
    }
/*	
    free((void *)&prem);
    free((void *)&ray);
*/
/* below frees the memory in ray */
    free_dmatrix(ray.para, 1,400,1,3); 	/* to store ray parameters */
    free_imatrix(ray.layer, 1,400,1,5);
    free_ivector(ray.lastlay,1,400);     	/* deepest layer of this branch ray can get */
    free_ivector(ray.nlast, 1,2); 	/* deepest layer for a ray of specific dist */
    if(ifkernel>0){
   	free_dvector(ray.theta, 1,NMAX);
 	free_dvector(ray.radius,1,NMAX);
   	free_dvector(ray.fac, 1,NMAX);
   	free_dvector(ray.tmp, 1,NMAX);
   	free_dvector(ray.vs, 1,NMAX);
   	free_dvector(ray.vp, 1,NMAX);
    }
/* below frees memory in prem */
    free_dvector(prem.r, 1,prem.tlay+2);   /* radius of each layer */
    free_dvector(prem.rho, 1,prem.tlay+2);
    free_dvector(prem.vpv, 1,prem.tlay+2);
    free_dvector(prem.vsv, 1,prem.tlay+2);
    free_dvector(prem.qshear, 1,prem.tlay+2);
    free_dvector(prem.qkappa,1,prem.tlay+2);
    free_dvector(prem.vph, 1,prem.tlay+2);
    free_dvector(prem.vsh,1,prem.tlay+2);
    free_dvector(prem.eta, 1,prem.tlay+2);
    free_dmatrix(prem.u, 1,2,1,prem.tlay+2);
    free_dmatrix(prem.ui, 1,2,1,prem.tlay+2);
    free_dmatrix(prem.delt, 1,2,1,prem.tlay+2);
    free_dmatrix(prem.ttime, 1,2,1,prem.tlay+2);

   
}

/*
 * read spherical Earth model (PREM)
 */
void GetSphModel(prem)
DECKPREM *prem;
{
double *r,*rho,*vpv,*vsv,*vph,*vsh,*eta,*qshear,*qkappa;
double dtdh,rr,rt,rtpower,val,coef[5];
double c1,c2,c3,c4,c5,c6,c7,c8,c9,r1,r2,dr,radius;
int i,j,k,l,knt,nreg,nic,noc,moho,nlay,ifs,npol,knt0,knt1;
int icb,cmb,tlay,mdlformat;
char s[132],temp[132];
char earthmod[256];
FILE *fp;

/* the following uses the modified prem model newprem.1263 */
  sprintf(earthmod, "%s","/scratch/troika23/gu/stacking/residual/newprem.1263");
  if((fp=fopen(earthmod,"r")) == NULL) {
     printf("check the input earth model");
     exit(1);
  }

  FGetLine(fp,s,132);                   /* get the first line */
  
  mdlformat = (s[49]=='0' && s[58]=='1') ? 1 : 2;
  
  if(mdlformat==1){                /* non-deck, anisotropic model */
/*
     printf("%s\n",s); 
*/
     sscanf(s,"%d %d %d %le %s %d %s %d %d",&nreg,&icb,&cmb,&radius,temp,&i,temp,&i,&moho);
/*
     printf("RADIUS=%lf\n",radius);
*/
     npol = 8;                     /* # of polynomial coef       */
          
/*
     printf("  reg     # of layer         r1            r2\n");
*/
                
     for(i=1,tlay = 0;i<=nreg;i++){  /* get total # of layers   */
         FGetLine(fp,s,132);
         sscanf(s,"%d %d %le %le",&nlay,&ifs,&r1,&r2);
/*
         printf("%5d %10d %5d %12.4lf  %12.4lf\n",i,nlay,ifs,r1,r2);
*/
         tlay+=nlay;
         for(j=1;j<=npol;j++)FGetLine(fp,s,132);
     }
     prem->radius=radius;
  }else if(mdlformat==2){              /* for layered model       */
     FGetLine(fp,s,132);               /* skip one line           */
     FGetLine(fp,s,132);
     sscanf(s,"%d %d %d %d",&tlay,&icb,&cmb,&moho);
  }
  
  prem->tlay  =tlay;
/*
  printf("total number of layers = %d\n",tlay);
*/

  prem->icb   =tlay-icb+1;
  prem->cmb   =tlay-cmb+1;
  prem->r     =r      = dvector(1,tlay+2);   /* radius of each layer */
  prem->rho   =rho    = dvector(1,tlay+2);
  prem->vpv   =vpv    = dvector(1,tlay+2);
  prem->vsv   =vsv    = dvector(1,tlay+2);
  prem->qshear=qshear = dvector(1,tlay+2);
  prem->qkappa=qkappa = dvector(1,tlay+2);
  prem->vph   =vph    = dvector(1,tlay+2);
  prem->vsh   =vsh    = dvector(1,tlay+2);
  prem->eta   =eta    = dvector(1,tlay+2);
  prem->u     =     dmatrix(1,2,1,tlay+2);
  prem->ui    =     dmatrix(1,2,1,tlay+2);
  prem->delt  =     dmatrix(1,2,1,tlay+2);
  prem->ttime =     dmatrix(1,2,1,tlay+2);

  if(mdlformat==1){                /* for non-deck, anisotropic model */
     rewind(fp);                           /* read the file again */
     FGetLine(fp,s,132);                   /* skip the first line */
     knt0=1;
     for(i=1;i<=nreg;i++){                 /* read the rest of the file */
         FGetLine(fp,s,132);
         sscanf(s,"%d %d %le %le",&nlay,&ifs,&r1,&r2);
         dr=(r2-r1)/(double)(nlay-1);      /* increment in radius  */
         
         for(j=1;j<=npol;j++){             /* read different coefficients */
             FGetLine(fp,s,132);
             sscanf(s,"%le%le%le%le%le",&coef[0],&coef[1],&coef[2],&coef[3],&coef[4]);
             rr=r1;
             knt=knt0;
             for(k=1;k<=nlay;k++,knt++,rr+=dr){   /* interplate at different r */
                 rtpower=rt=rr/radius;
                 val     = coef[0];
                 knt1=tlay-knt+1;
                 for(l=1;l<=4;l++,rtpower*=rt)val+=coef[l]*rtpower;

                 if(j==1){                    /* interplate radius and rho    */
                         r[knt1]=(float)rr;   /* reduce some accuracy so that */
                         rho[knt1]=val;       /* discontinuity could be found */
                 }else if(j==2){
                         vpv[knt1]=val;
                 }else if(j==7){			/* other part of the program uses vsv, fake it to use vsh */
                         vsv[knt1]=val;
                 }else if(j==4){
                         qshear[knt1]=(val!=0.0) ? 1.0/val : 0.0;
                 }else if(j==5){
                         qkappa[knt1]=(val!=0.0) ? 1.0/val : 0.0;
                 }else if(j==6){
                         vph[knt1]=val;
                 }else if(j==3){
                         vsh[knt1]=val;
                 }else if(j==8){
                         eta[knt1]=val;
                 }
             }
         
         }
         knt0=knt;
     }

  }else{
 /*    for(i=1;i<=tlay;i++){
         FGetLine(fp,s,132);
         sscanf(s,"%lf %lf %lf %lf %lf %lf",&c1,&c2,&c3,&c4,&c5,&c6);
         knt=tlay-i+1;
         r[knt]     =c1*0.001;  
         rho[knt]   =c2*0.001;
         vpv[knt]   =c3*0.001;
         vsv[knt]   =c4*0.001;
         qshear[knt]=c5;
         qkappa[knt]=c6;
     } */
    for(i=1;i<=tlay;i++){
         FGetLine(fp,s,132);
         sscanf(s,"%lf %lf %lf %lf %lf %lf %lf %f %lf",&c1,&c2,&c3,&c4,&c5,&c6,&c7,&c8,&c9);
         knt=tlay-i+1;
         r[knt]     =c1*0.001;  
         rho[knt]   =c2*0.001;
         vpv[knt]   =c3*0.001;
         vsv[knt]   =c4*0.001;
         qshear[knt]=c5;
         qkappa[knt]=c6;
     } 
     prem->radius=r[1];
  }
  
/*
  printf("RMOHO=%lf\n",r[tlay-moho+1]);
*/
  prem->rmoho=r[tlay-moho+1];
  fclose(fp);
  
}

void SplitModel(prem,dep)
DECKPREM *prem;
double dep;
{
double *r,srad,**u,**ui;
double *array[9],drr;
int   i,j,j1,j2,im1,isor,tlay,numreg;

     r=array[0]=prem->r;                       /* radius for each layer */
     array[1]=prem->rho;                       /* density               */
     array[2]=prem->vpv;
     array[3]=prem->vsv;
     array[4]=prem->qshear;
     array[5]=prem->qkappa;
     array[6]=prem->vph;
     array[7]=prem->vsh;
     array[8]=prem->eta;
     u       =prem->u;
     ui      =prem->ui;
     tlay=prem->tlay;
     srad=prem->radius-dep;                  /* convert depth to radius */
     
     if(srad>r[1] || srad <=r[prem->cmb]){   /* check whether source is in valid reg */
        printf("Valid source region is between dep=%12.4lf -->%10.4lf\n",
                0.0,r[1]-r[prem->cmb]);
        errormessage(11);
     }
     prem->icb  +=2;                            /* add two layers due to the source layer */
     prem->cmb  +=2;
     
     for(i=2;i<=tlay;i++)if(srad>=r[i])break;   /* find which layer the source is in */
     
     isor=i-1;
/*
     printf(" source layer = %d\n",isor);
*/
     prem->isor = isor+2;

     for(i=tlay;i>isor;i--){                    /* add two layers */
         for(j=0;j<=8;j++)array[j][i+2]=array[j][i];
     }
     prem->tlay=tlay=tlay+2;                    /* total # of layers increased by  2 */
     
     array[0][isor+1]=array[0][isor+2]=srad;    /* linear interpolate to get value for */
     for(j=1;j<=8;j++){                         /* the two new layers for the source   */
         array[j][isor+2]=
              array[j][isor+1]=array[j][isor]+
              (array[j][isor+3]-array[j][isor])*(srad-array[0][isor])/
              (array[0][isor+3]-array[0][isor]);
     }

     numreg=1;                                        /* find out the layer number for the */
     for(i=1;i<tlay;i++)if(r[i]==r[i+1])numreg++;     /* discontinuities                   */
     prem->numreg=numreg;
     prem->icn= IntVec(1,numreg+1);
     (*prem).icn[1]=1;

     for(i=1,j=2;i<tlay;i++){
         if(r[i]==r[i+1]){
            (*prem).icn[j]=i+1;
#if PRINT
            printf("%4d icn=%4d\n",j,(*prem).icn[j]);
#endif
            j++;
         }
     }
     (*prem).icn[j]=tlay+1;
/*
     printf("%d icn=%d\n",j,(*prem).icn[j]);
*/

    prem->itop = IntVec(1,numreg);
    prem->ibot = IntVec(1,numreg);
    prem->nps  = IntMatrix(1,2,1,numreg);
    
    for(i=1;i<=numreg;i++){                                 /* r/v at the discontinuities */
        j1=(*prem).itop[i]=(*prem).icn[i];
        j2=(*prem).ibot[i]=(*prem).icn[i+1]-1;
    }
/*
 * calculate r/v 
 */
   for(i=1;i<=tlay;i++){
     u[1][i]= (*prem).r[i]/(*prem).vpv[i];
     u[2][i]= (*prem).vsv[i]!=0.0 ? (*prem).r[i]/(*prem).vsv[i]:0.0;
#if PRINT   
	printf("prem.r[i]=%f,  vsv =%f\n", (*prem).r[i],(*prem).vsv[i]);
#endif
   }
#if PRINT   
   for(i=1;i<=tlay;i++)
     printf("%5d %12.4lf %12.4lf\n",i,u[1][i],u[2][i]);
#endif
   
/*
 * calculate  log(ri*v1/vi/r1) 
 */
   ui[1][tlay]=ui[2][tlay]=0.0;
   for(i=2;i<tlay;i++){
       im1=i-1;
       drr=log(r[i]/r[im1]);
       for(j=1;j<=2;j++){
          ui[j][im1]=(u[j][i]!=0.0 && u[j][im1]!=0.0 && drr!=0.0) ? 
                     log(u[j][i]/u[j][im1])/drr : 0.0;
       }
   }
   
#if PRINT   
   for(i=1;i<=tlay;i++){
     printf("%5d %12.4lf %12.4lf\n",i,ui[1][i],ui[2][i]);
   }
#endif
}

void GetRayName(ray,prem,rayname)
RAY *ray;
DECKPREM prem;
char *rayname;
{
char *rname;
int i,ind,nleg,isor,cmb,icb,region,irec,isfc;
int dir,type;
int *raytype,*raydir,*rayregion,*raybeglay,*rayendlay;
float reflect;

  rname=ray->rname;
  raytype=ray->raytype;
  raydir=ray->raydir;
  rayregion=ray->rayregion;
  raybeglay=ray->raybeglay;
  rayendlay=ray->rayendlay;
  cmb =prem.cmb;	    /* core mantle boundary */
  icb =prem.icb;	    /* inner core outer core boundary */
  isor=prem.isor;	    /* source layer */
  irec=1;             /* assume the receiver is on the surface */
  isfc=1;             /* reflection is on the earth surface    */
  
/*
  printf("Input rayname\n");
  scanf("%s",rname);
  printf("Ray name=%s\n",rname);
*/  
  strcpy(rname, rayname);
  reflect=RADIUS;
  
  if(!strncmp(&rname[1],"220",3)){
      strcpy(rname,"SS");
      reflect=RADIUS-220.0;
  }else if(!strncmp(&rname[1],"400",3)){
      strcpy(rname,"SS");
      reflect=RADIUS-400.0;
  }else if(!strncmp(&rname[1],"670",3)){
      strcpy(rname,"SS");
      reflect=RADIUS-670.0;
  }else if(!strncmp(&rname[1],"520",3)){
      strcpy(rname,"SS");
      reflect=RADIUS-520.0;
  }
  nleg=strlen(rname);
  
  for(i=prem.tlay;i>=1;i--){
    /*   printf("prem.r[i], reflect %f %f\n", prem.r[i], reflect); */
       if(fabs(prem.r[i]-reflect)<0.1){
/*
          printf("reflection surface is found at layer %d\n",i);
*/
          isfc=i;
          break;
       }
  }  
   
  ray->reflay=isfc;
                                                        /* including reflections    */
  rayregion[0]=MANTLEREG;                                 /* the source is always in  */
                                                          /* the mantle               */
  if(rname[0]=='Q'||rname[0]=='q'||rname[0]==' '||nleg<1){
      exit(1);                                                /* normal termination */
  }else if(rname[0]=='P'){
      raytype[0]=PWAVE;
      raydir[0] =DOWN;
      raybeglay[0]=isor;
  }else if(rname[0]=='S'){
      raytype[0]=SWAVE;
      raydir[0] =DOWN;
      raybeglay[0]=isor;
  }else if(rname[0]=='p' && nleg>1){
      raytype[0]=PWAVE;
      raydir[0] =UP;
      raybeglay[0]=isor-1;
  }else if(rname[0]=='s' && nleg>1){
      raytype[0]=SWAVE;
      raydir[0] =UP;
      raybeglay[0]=isor-1;
  }else  errormessage(1);
  
  if(nleg==1)rayendlay[0]=irec;                    /* direct P or S wave, the ray leg always */
                                                   /* ends  at the  receiver layer           */

  ind=1;                                           /* ray leg index, excluding refections    */
  for(i=1;i<nleg;i++){                             /* for the rest of the legs of  ray       */

      if      (rname[i]=='P'||rname[i]=='p'){
         region=MANTLEREG;
         type  =PWAVE;
      }else if(rname[i]=='S'||rname[i]=='s'){
         region=MANTLEREG;
         type  =SWAVE;
      }else if(rname[i]=='K'){
         region=OUTCOREREG;
         type  =PWAVE;
      }else if(rname[i]=='J'){
         region=INNERCOREREG;
         type  =SWAVE;
      }else if(rname[i]=='I'){
         region=INNERCOREREG;
         type  =PWAVE;
      }else if(rname[i]=='c'||rname[i]=='i'){
         region=type =REFLECT;
      }
      if(rname[i-1]=='P'||rname[i-1]=='S'){
         if( rname[i]=='P'||rname[i]=='S'){
             rayendlay[ind-1]=raybeglay[ind]=isfc;
             dir=DOWN;
         }else if(rname[i]=='K'){
             rayendlay[ind-1] =cmb-1;
             if(raybeglay[ind-1]==cmb-1)errormessage(2); /* P or S leg which begins from*/ 
             raybeglay[ind] =cmb;                        /* cmb can not end at cmb      */
             dir =DOWN;
         }else if(rname[i]=='c'){
             rayendlay[ind-1] =cmb-1;
             dir =REFLECT;
             if(raybeglay[ind-1]==cmb-1)errormessage(3); /* P or S leg which begins from*/ 
                                                         /* cmb  can not end at cmb     */
         }else errormessage(4);
            
      }else if(rname[i-1]=='K'){
         if( rname[i]=='P'||rname[i]=='S'){
             rayendlay[ind-1]=cmb;
             raybeglay[ind]  =cmb-1;
             dir=UP;
         }else if(rname[i]=='K'){
             rayendlay[ind-1]=raybeglay[ind]=cmb;
             dir=DOWN;
         }else if(rname[i]=='I'||rname[i]=='J'){
             rayendlay[ind-1]=icb-1;
             if(raybeglay[ind-1]==icb)errormessage(5); /* K leg which begins from   */ 
             raybeglay[ind]  =icb;                     /*  icb can not end at icb   */
             dir=DOWN;
         }else if(rname[i]=='i'){
             rayendlay[ind-1] =icb-1;
             dir  =REFLECT;
         }else errormessage(6);
      }else if(rname[i-1]=='I'||rname[i-1]=='J'){
         if(rname[i]=='I'||rname[i]=='J'){
             rayendlay[ind-1]=raybeglay[ind]=icb;
             dir=DOWN;
         }else if( rname[i]=='K'){
             rayendlay[ind-1]=icb;
             raybeglay[ind]  =icb-1;
             dir=UP;
         }else errormessage(7);
      }else if(rname[i-1]=='p'||rname[i-1]=='s'){
         if( rname[i]=='P'||rname[i]=='S'){
             rayendlay[ind-1]=raybeglay[ind]=isfc;
             dir=DOWN;
         }else errormessage(8);
      }else if(rname[i-1]=='c'){
         if( rname[i]=='P'||rname[i]=='S'){
             rayendlay[ind-1]=raybeglay[ind]=cmb-1;
             dir=UP;
         }else errormessage(9);
      }else if(rname[i-1]=='i'){
         if( rname[i]=='K'){
             rayendlay[ind-1]=raybeglay[ind]=icb-1;
             dir=UP;
         }else errormessage(10);
      }
      
      if(type!=REFLECT){
         raytype[ind]=type;
         raydir[ind]=dir;
         rayregion[ind++]=region;
      }
      
   }
   
   rayendlay[ind-1]=irec;   /* the last leg always ends at the receiver */
   
   ray->nleg=ind;
   
#if PRINT
   printf("Number of ray legs=%d\n",ind);

   for(i=0;i<ind;i++){
       printf("  %2d ",i+1);
       printf("  %4d %4d   ",raybeglay[i],rayendlay[i]);
       if(rayregion[i]==MANTLEREG)   printf(" MANTLE   ");
       if(rayregion[i]==INNERCOREREG)printf(" INNERCORE");
       if(rayregion[i]==OUTCOREREG)  printf(" OUTERCORE");
       if(raydir[i]==DOWN)           printf(" DOWN");
       if(raydir[i]==UP)             printf(" UP  ");
       if(raytype[i]==PWAVE)         printf(" P-WAVE");
       if(raytype[i]==SWAVE)         printf(" S-WAVE");
       
       (raybeglay[i]>=rayendlay[i] && raydir[i]!=UP) 
       ? printf(" turning ray\n") :  printf("\n");
   }
#endif

}

void GetRayPara(ray,prem,ifkernel)
RAY *ray;
DECKPREM prem;
int ifkernel;
{
int *raybeglay,*rayendlay,*rayregion,*raydir,*raytype,**nps,temp;
int i,j,lay0,lay1,isource,region,numreg,itube;

  rayregion=ray->rayregion;
  raydir=ray->raydir;
  raytype=ray->raytype;
  raybeglay=ray->raybeglay;
  rayendlay=ray->rayendlay;
  numreg   =prem.numreg;
  nps      =prem.nps;
  ray->para=dmatrix(1,400,1,3);   /* to store ray parameters */
  ray->layer=IntMatrix(1,400,1,5);
  ray->lastlay=IntVec(1,400);     /* deepest layer of this branch ray can get */
  ray->nlast=IntVec(1,2);         /* deepest layer for a ray of specific dist */
                                  /* can reach, nlast[1]-- for P, [2] -- for S*/
  if(ifkernel>0){
   	ray->theta  = dvector(1,NMAX);
 	ray->radius = dvector(1,NMAX);
   	ray->fac    = dvector(1,NMAX);
   	ray->tmp    = dvector(1,NMAX);
   	ray->vs     = dvector(1,NMAX);
   	ray->vp     = dvector(1,NMAX);
  }
  
  for(i=1;i<=numreg;i++)prem.nps[1][i]=prem.nps[2][i]=0;
  
  itube=0;
  
  for(i=0;i<ray->nleg;i++){                    /* loop through all the ray legs */
      lay0=raybeglay[i];
      lay1=rayendlay[i];
/*
      printf(" layer0=%d layer1=%d\n",lay0,lay1);
*/
      if((lay1<=lay0 || ray->reflay!=1) && raydir[i]!=UP){         /* for ray which turns */
         if      (rayregion[i]==MANTLEREG){
            lay1=prem.cmb-1;
            temp=ray->reflay;                  /* top reflection layer */
         }else if(rayregion[i]==OUTCOREREG){
            lay1=prem.icb-1;
            temp=prem.cmb;
         }else if(rayregion[i]==INNERCOREREG){
            lay1=prem.tlay;
            temp=prem.icb;
         }
         RayTube(ray,prem,lay0,lay1,raytype[i],TURNING,&itube);  /* downgoing leg */
         lay0=lay1;
         lay1=temp;
         if(i==(ray->nleg-1) && ray->reflay!=1)lay1=1;	/* ended at the receiver */
         RayTube(ray,prem,lay0,lay1,raytype[i],TURNING,&itube);  /* upgoing   leg */
      }else{
         RayTube(ray,prem,lay0,lay1,raytype[i],THROUGH,&itube);  /* ray which doesnot turn */
      }
  }
  
  ray->itube=itube;
  
#if PRINT 
  printf(" nps -- contributions for different layers\n");
  for(i=1;i<=numreg;i++){
      printf("%d %d %d\n",i,prem.nps[1][i],prem.nps[2][i]);
  }
#endif
  
}

void  RayTube(ray,prem,lay0,lay1,raytype,raychar,itube)
DECKPREM prem;
RAY *ray;
int lay0,lay1,raytype,raychar,*itube;
{
int  i,reg0,reg1,**layer;

   layer=ray->layer;

   for(reg0=1;reg0<=prem.numreg;reg0++)
       if(lay0>=prem.itop[reg0] && lay0<=prem.ibot[reg0])break;
   
   for(reg1=1;reg1<=prem.numreg;reg1++)
       if(lay1>=prem.itop[reg1] && lay1<=prem.ibot[reg1])break;
       
   if(lay1>=lay0){
      for(i=reg0;i<=reg1;i++){
         (*itube)++;
         layer[*itube][1]=i;
         layer[*itube][2]=prem.itop[i];
         layer[*itube][3]=prem.ibot[i];
         layer[*itube][4]=raychar;
         layer[*itube][5]=raytype;
         (raytype==PWAVE) ? prem.nps[1][i]++ : prem.nps[2][i]++;
      }
   }else{
      for(i=reg0;i>=reg1;i--){
         (*itube)++;
         layer[*itube][1]=i;
         layer[*itube][2]=prem.ibot[i];
         layer[*itube][3]=prem.itop[i];
         layer[*itube][4]=raychar;
         layer[*itube][5]=raytype;
         (raytype==PWAVE) ? prem.nps[1][i]++ : prem.nps[2][i]++;
      }
   }
}

void errormessage(type)
int  type;
{

 if(type>=1 && type<=10){
     printf("!!!!!Error %2d!!!!! Wrong ray name\n",type);
 }else if(type==11){
     printf("!!!!!Error 11!!!!! source depth out of range\n");
 }else if(type==12){
     printf("!!!!!Error 12!!!!! Root must be bracked for bisection in FindPara\n");
 }else if(type==13){
     printf("!!!!!Error 13!!!!! Too many bisections in FindPara\n");
     printf("or accuracy is too high, increase NMAX or XACC in tttable.h\n");
 }else if(type==14){
     printf("!!!!!Error 14!!!!! Max dimension exceeds the limit\n");
     printf("Increase NMAX in tttable.h\n");
 }else if(type==15){
     printf("!!!!!Error 15!!!!! too few points in drspln\n");
 }else if(type==16){
     printf("!!!!!Error 16!!!!! too few points in drspln\n");
 }else if(type==17){
     printf("!!!!!Error 17!!!!! in DChebyFun, kmax>13\n");
 }else if(type==18){
          printf("!!!!!Error 18!!!!!\n");
 }else if(type==19){
          printf("!!!!!Error 19!!!!! wrong Choice of branch\n");
 }else{
     printf("!!!!!Error %2d!!!!!\n",type);
 }
 exit(1);
}


void GetRayBranch(ray,prem)
RAY *ray;
DECKPREM prem;
{
int i,j,ii,itube,ib,ib2,it,lastlay[1000],pchar[1000];
int slay,elay,region,wavetype,raychar;
double t,pmin[1000],pmax[1000],p0,p1,p2,p3;


  itube=ray->itube;
#if PRINT
  for(i=1;i<=itube;i++){
      Para(prem,ray->layer[i][1],ray->layer[i][5],&p0,&p1);
      printf("%4d %4d %4d %4d %4d %12.4f %12.4f\n",
         ray->layer[i][1],ray->layer[i][2],ray->layer[i][3],
         ray->layer[i][4],ray->layer[i][5],p0,p1);
  }
#endif
  
  pmin[0]= 0.0;
  pmax[0]= 1.0e100;
  lastlay[0]=0; 
  pchar[0]= THROUGH;
  ib=1;
  
  for(i=1;i<1000;i++)lastlay[i]=0;
  
  for(i=1;i<=itube;i++){                                   /* loop for the rest of legs    */
      slay=ray->layer[i][2];                               /* starting layer        */
      elay=ray->layer[i][3];                               /* ending layer          */
      region=ray->layer[i][1];
      wavetype=ray->layer[i][5];
      raychar=ray->layer[i][4];
      Para(prem,region,wavetype,&p0,&p1);                  /* get pmin & pmax for the layer */
      for(ii=j=0;j<ib;j++){                                /* loop for every branch */
        if(pchar[j]==THROUGH){
          if(raychar==THROUGH){
             pmax[j]=min(pmax[j],p0);                      /* go thru, pmin stays the same   */
             lastlay[j]=max(lastlay[j],elay);
          }else if(raychar==TURNING){
             if(ray->layer[i+1][2]<ray->layer[i+1][3]){    /* not last region */
                pmax[ib+ii]=min(pmax[j],p0);
                pmin[ib+ii]=pmin[j];
                lastlay[ib+ii]=max(lastlay[ib+ii],elay);
                pchar[ib+ii]=THROUGH;
                if(pmax[ib+ii]>=pmin[ib+ii])ii++;
             }
             pmin[j]=max(pmin[j],p0);                      /* turning branch */
             pmax[j]=min(pmax[j],p1);                      /* turning branch */
             pchar[j]=TURNING;
             lastlay[j]=max(lastlay[j],elay);
          }
        }
      }          
          
      ib+=ii;
      
      if(elay==1){
         for(j=0;j<ib;j++)pchar[j]= THROUGH;
      }
  }

#if PRINT 
  printf("initial para ib=%d\n",ib);
  for(i=0;i<ib;i++){
     printf("%5d %12.4f %12.4f\n", lastlay[i], pmin[i],pmax[i]);
  }
#endif
  
  for(i=j=0;i<ib;i++){           /* eliminate impossible rays */
     if(pmin[i]<pmax[i]){
        pmin[j]=pmin[i];
        pmax[j]=pmax[i];
        lastlay[j]=lastlay[i];
        j++;
     }
  } 
  
  ib=j;
  
  for(i=1,j=0;i<ib;i++){
     pmin[j]=pmin[i-1];
     lastlay[j]=lastlay[i-1];
     if(fabs(pmin[j]-pmax[i])>0.001){
        j++;
        pmax[j]=pmax[i];
        lastlay[j]=lastlay[i];
     }
  }
   
  pmin[j]=pmin[ib-1];
  lastlay[j]=lastlay[ib-1];
  
  ib=j+1;
  
#if PRINT 
  printf("final para, ib=%d\n",ib);
#endif
  
  ib2=ib/2;
     
  for(i=0;i<ib2;i++){
      DSwap(&pmax[i],&pmax[ib-i-1]);
      DSwap(&pmin[i],&pmin[ib-i-1]);
      ISwap(&lastlay[i],&lastlay[ib-i-1]);
  }

  ray->nb=ib;
  for(i=0;i<ib;i++){
      ray->para[i+1][1]=pmin[i];
      ray->para[i+1][2]=pmax[i];
      ray->lastlay[i+1]=lastlay[i];
#if PRINT 
     printf("%5d %12.4f %12.4f\n", lastlay[i], pmin[i],pmax[i]);
#endif
  }
 
}

void Para(prem,region,wavetype,pmin,pmax)
DECKPREM prem;
int region,wavetype;
double *pmin,*pmax;
{
int i0,i1;
double v0,v1;

    i0=prem.ibot[region];
    i1=prem.itop[region];
    if(wavetype==PWAVE){
       v0=prem.vpv[i0];
       v1=prem.vpv[i1];
    }else{
       v0=prem.vsv[i0];
       v1=prem.vsv[i1];
    }
    *pmin=prem.r[i0]/v0;
    *pmax=prem.r[i1]/v1;
}


void IntgrateDelTim(ray,para,prem,ttime,delta,ierr)
RAY ray;
DECKPREM prem;
double para,*ttime,*delta;
int  *ierr;
{
int i,j,k,itop,ibot,numreg;
int **nps;
double tim,del,x,dnps,dx,y,qs,qr,b,etim,ex,egrad;
double dtim,ddel;
double **u,**ui,uu,qq,*r;
double temptim, tempx,tempdtim, tempdx;

  numreg=prem.numreg;
  nps=prem.nps;
  r=prem.r;
  u=prem.u;
  ui=prem.ui;
  
  if(para==0.0){
     VertTime(prem,ray,ttime,delta);
     return;
  }
  
  tim=x=0.0;
  temptim=tempx = 0.0;
  for(k=1;k<=2;k++){                   /* loop for P and S */
     for(i=1;i<=numreg;i++){           /* loop for different region */
        if(nps[k][i]>0){               /* if there is contribution from any ray leg */
           dnps=(double)nps[k][i];
           itop=prem.icn[i];
           ibot=prem.icn[i+1]-2;
           dtim=dx=0.0;
           tempdtim = tempdx = 0.0;
           uu=u[k][itop];
           y=uu-para;
           if(y>0.0){
              qq=y*(uu+para);
              qs=sqrt(qq);
              qr=atan2(qs,para);
              for(j=itop;j<=ibot;j++){  /* loop for different layer */
                b=ui[k][j];
                if(b!=0.0){
                   etim=qs;
                   ex=qr;
                   uu=u[k][j+1];
                   if (uu>para){
                       qq=(uu-para)*(uu+para);
                       qs=sqrt(qq);
                       qr=atan2(qs,para);
                       ex+=-qr;
                       etim+=-qs;
                   }
                }else{
                   b=1.0/log(r[j]/r[j+1]) ;
                   if(b==0.0)b=1.0e30;
                   ex=para/qs;
                   etim=qs+para*ex;
                }
                dx+=ex/b;
                dtim+=etim/b;
                if(j >= 141 && j <= 166) { /* between 520 and 400km */
		   temptim+= etim/b;
                   tempx+= ex/b;
		}
                if(uu<=para)break; 
             }                        /* end of layer loop */
           }else if(y==0.0){
              break;                  /* break the diffrent region loop */
           }else{
              *ierr=2;                 /* found error */
              return;
           }
           x+=dnps*dx;
           tim+=dnps*dtim;
           if(uu<=para)break;         /* break different region loop  */
       }                              /* end of if(nps)               */
    }                                 /* end of different region loop */
 }                                    /* end of P and S loop */
 
 *ierr=0;                              /* no error, normal finish */
 *delta=x-tempx;
 *ttime=tim-temptim;
}

void FindPara(prem,p1,x1,p2,x2,xacc,dist,p,delta,ierr)
double p1,x1,p2,x2,xacc,dist,*p,*delta;
int *ierr;
DECKPREM prem;
{
double f,fmid,rtb,xmid,dx;
int j;

    if      (dist==x1){
       *p=p1;
       *delta=dist;
       return;
    }else if(dist==x2){
       *p=p2;
       *delta=dist;
       return;
    }

    x1-=dist;
    x2-=dist;
    f=x1;
    fmid=x2;
    
    if(f*fmid>=0.0)errormessage(12);
    rtb = f<0.0 ? (dx=p2-p1,p1) : (dx=p1-p2,p2);
    
    for(j=1;j<=JMAX;j++){
        dx*=0.5;
        xmid=rtb+dx;
        IntgrateDel(xmid,prem,&fmid,ierr);
        fmid-=dist;
        if(fmid<0.0)rtb=xmid;
        if(fabs(dx)<xacc || fmid==0.0){
           *delta=fmid+dist;
           *p=xmid;
            return;
        }
    }
    errormessage(13);    
}

void IntgrateDel(para,prem,delta,ierr)
DECKPREM prem;
double para,*delta;
int  *ierr;
{
int i,j,k,itop,ibot,numreg;
int **nps;
double x,dx,y,qs,qr,b,ex;
double **u,**ui,uu,*r;

  numreg=prem.numreg;
  nps=prem.nps;
  r=prem.r;
  u=prem.u;
  ui=prem.ui;
  
  for(x=0.0,k=1;k<=2;k++){                   /* loop for P and S */
     for(i=1;i<=numreg;i++){           /* loop for different region */
        if(nps[k][i]>0){               /* if there is contribution from any ray leg */
           itop=prem.icn[i];
           ibot=prem.icn[i+1]-2;
           dx=0.0;
           uu=u[k][itop];
           y=uu-para;
           if(y>0.0){
              qs=sqrt(y*(uu+para));
              qr=atan2(qs,para);
              for(j=itop;j<=ibot;j++){  /* loop for different layer */
                b=ui[k][j];
                if(b!=0.0){
                   ex=qr;
                   uu=u[k][j+1];
                   if (uu>para){
                       qs=sqrt((uu-para)*(uu+para));
                       qr=atan2(qs,para);
                       ex+=-qr;
                   }
                }else{
                   b=1.0/log(r[j]/r[j+1]);
                   ex=para/qs;
                }
                dx+=ex/b;
                if(uu<=para)break;
             }                        /* end of layer loop              */
           }else if(y==0.0){
              break;                  /* break the diffrent region loop */
           }else{
              *ierr=2;                /* found error                    */
              return;
           }
           x+=(double)nps[k][i]*dx;
           if(uu<=para)break;         /* break different region loop  */
       }                              /* end of if(nps)               */
    }                                 /* end of different region loop */
 }                                    /* end of P and S loop */
 
 *ierr=0;                              /* no error, normal finish */
 *delta=x;
}

double CalDtDh(prem,ray,para)
DECKPREM prem;
RAY ray;
double para;                        /* ray parameter              */
                                    /*                for P or S dir=DOWN */
{
int l1,l2,isor,**layer;
double *r,eta,rr,*vp,*vs,dtdh;

   isor=prem.isor;                  /* the layer the source is in */
   r   =prem.r;
   vp  =prem.vpv;
   vs  =prem.vsv;
   rr  =r[isor];
   layer=ray.layer;
   
   l1=layer[1][2];
   l2=layer[1][3];
   
   eta = (layer[1][5]==PWAVE) ? rr/vp[isor] : rr/vs[isor];
   
   dtdh=-sqrt(eta*eta-para*para)/rr;

   if(l1>l2)dtdh=-dtdh;             /* for upgoing waves (p and s) */
   
   return dtdh;
}

/*
 * for p=0.0 case
 */
void VertTime(prem,ray,ttime,delta)
RAY ray;
DECKPREM prem;
double *ttime,*delta;
{
int i,k,inc,itube,tlay;
int slay,elay,wavetype;
double del,x,*r,*vpv,*vsv,dr,v;

  tlay=prem.tlay;
  vpv=prem.vpv;
  vsv=prem.vsv;
  
  *delta=*ttime=0.0;
  itube=ray.itube;
  r=prem.r;

  for(i=1;i<=itube;i++){                                       /* loop for the rest of legs    */
      slay=ray.layer[i][2];                                    /* starting layer        */
      elay=ray.layer[i][3];                                    /* ending layer          */
      wavetype=ray.layer[i][5];
      if(elay==tlay){
         *delta= (*delta<0.5*PI)? *delta+PI : *delta-PI;
      }
      
      k=slay;
      inc = ((elay-slay)>0) ? 1: -1;
      while(1){
        if(k==elay)break;
        dr=fabs(r[k]-r[k+inc]);
        v=(wavetype==PWAVE) ? vpv[k] : vsv[k];
        *ttime+=dr/v;
        k+=inc;
      }
  }
  
}

void PrintPrem(prem)
DECKPREM prem;
{
double *r,*rho,*vpv,*vsv,*qshear,*qkappa,*vph,*vsh,*eta;
int i,j1,j2,tlay;

     r  =prem.r;
     rho=prem.rho;
     vpv=prem.vpv;
     vsv=prem.vsv;
     qshear=prem.qshear;
     qkappa=prem.qkappa;
     vph=prem.vph;
     vsh=prem.vsh;
     eta=prem.eta;
     tlay=prem.tlay;
/*     
     printf("Number of regions separated by discontinuities = %d\n",prem.numreg);
     printf("Total number of layers in the model = %d\n",prem.tlay);
     printf("Core mantle boundary is at layer %4d\n",prem.cmb);
     printf("Inner core boundary  is at layer %4d\n",prem.icb);
     printf("Earthquake source   is at layer %4d\n",prem.isor);
*/
     
#if PRINT
     for(i=1;i<=tlay;i++){
         printf("%5d %12.4lf %9.4lf %9.4lf %9.4lf %9.2lf %9.2lf\n",
               i,r[i],rho[i],vpv[i],vsv[i],qkappa[i],qshear[i]);
         if(i!=tlay && r[i]==r[i+1])
            printf("discontinuity at r=%12.4lf %12.4lf\n",r[i],r[i+1]);
     }
     for(i=1;i<=prem.numreg+1;i++)
         printf(" discon at layer =%d\n",prem.icn[i]);
#endif
     

}

void CheckDepth(prem,depth)
DECKPREM prem;
double *depth;
{ /* 	this is to make sure that the depth of eq doens't coincide 
	with model discontinuities */
double *r,*rho,*vpv,*vsv,*qshear,*qkappa,*vph,*vsh,*eta;
int i,j1,j2,tlay;

     r  =prem.r;
     rho=prem.rho;
     vpv=prem.vpv;
     vsv=prem.vsv;
     qshear=prem.qshear;
     qkappa=prem.qkappa;
     vph=prem.vph;
     vsh=prem.vsh;
     eta=prem.eta;
     tlay=prem.tlay;
     
     for(i=1;i<=tlay;i++){
         if(i!=tlay && r[i]==r[i+1])
		if(fabs(r[i]-(6371.-*depth))<0.01){
			*depth+=0.001;
			printf("depth changed to %lf\n", *depth);
		}
     }

}

void CalThetaR(para,prem,ray,ierr)
DECKPREM prem;
RAY      *ray;
double   para;
int     *ierr;
{
int i,j,k,itop,ibot,numreg;
int **nps;
double **delt,**ttime,x,y,qs,qr,b,ex,bx,temp;
double **u,**ui,uu,*r;

  numreg=prem.numreg;
  nps=prem.nps;
  r=prem.r;
  u=prem.u;
  ui=prem.ui;
  delt=prem.delt;
  ttime=prem.ttime;
  
  for(k=1;k<=2;k++){                   /* loop for P and S */
     for(i=1;i<=numreg;i++){           /* loop for different region */
        if(nps[k][i]>0){               /* if there is contribution from any ray leg */
           itop=prem.icn[i];
           ibot=prem.icn[i+1]-1;
           delt[k][ibot+1]=ttime[k][ibot+1]=0.0;
           uu=u[k][itop];
           y=uu-para;
           if(y>0.0){
              qs=sqrt(y*(uu+para));
              qr=atan2(qs,para);
              for(j=itop;j<=ibot;j++){  /* loop for different layer */
                ray->nlast[k]=j;
                b=ui[k][j];
                if(b!=0.0){
                   ex=qr;
                   bx=qs;
                   uu=u[k][j+1];
                   if (uu>para){
                       qs=sqrt((uu-para)*(uu+para));
                       qr=atan2(qs,para);
                   }else{
                       qr=qs=0.0;
                   }
                   ttime[k][j]=(bx-qs)/b;
                   delt[k][j]=(ex-qr)/b;
                }else{
                   temp=log(r[j]/r[j+1])/qs;
                   delt[k][j]=para*temp;
                   ttime[k][j]=b*b*temp;
                }
                if(uu<=para)break;
             }                        /* end of layer loop */
           }else if(y==0.0){
              break;                  /* break the diffrent region loop */
           }else{
              *ierr=2;                /* found error */
              return;
           }
           if(uu<=para)break;         /* break different region loop  */
       }                              /* end of if(nps)               */
    }                                 /* end of different region loop */
 }                                    /* end of P and S loop */
 
 *ierr=0;                              /* no error, normal finish */

#if PRINT 
  x=0.0;
  for(i=1;i<=numreg;i++){              /* loop for different region */
      itop=prem.icn[i];
      ibot=prem.icn[i+1]-1;
/*
      printf("itop=%d ibot=%d\n",itop,ibot); 
*/
      for(j=itop;j<=ibot;j++){  /* loop for different layer */
/*
          printf("%d %12.4f %12.4f %12.4f %12.4f\n",
                  j,delt[1][j]/RAD,ttime[1][j],delt[2][j]/RAD,ttime[2][j]);
*/
          x+=delt[1][j];
      }
  }
  
  printf(" total =%f\n",temp/RAD);
#endif
}

void RayPath(para,prem,ray,ierr,nn,diff,dd,region)
DECKPREM prem;
RAY      ray;
double   para,dd;
int      *ierr,*nn,diff,region;
{
int *raybeglay,*rayendlay,*rayregion,*raydir,*raytype;
int i,j,lay0,lay1,numreg;
int *nlast,npath,k,l,inc,dir;
double *radius,*theta,delta,**ttime,**delt,*r,time;
double d,uu,**u,rr,*fac,rmoho,*vp,*vs;

  rayregion=ray.rayregion;
  raydir=ray.raydir;
  raytype=ray.raytype;
  raybeglay=ray.raybeglay;
  rayendlay=ray.rayendlay;
  nlast    =ray.nlast;
  theta    =ray.theta;
  radius   =ray.radius;
  fac      =ray.fac;
  vp		=ray.vp;
  vs		=ray.vs;
  delt   =prem.delt;
  numreg =prem.numreg;
  ttime  =prem.ttime;
  u=prem.u;
  r=prem.r;
  rmoho=prem.rmoho;
  
  
/*   printf("nlast=%d\n",nlast[1]); */
  
  delta =0.0;
  npath = 0;
  

  for(i=1;i<=ray.itube;i++){                 /* loop through all the ray legs */
    lay0=ray.layer[i][2];
    lay1=ray.layer[i][3];
    k= (ray.layer[i][5]==PWAVE) ? 1 : 2;     /* P or S leg */
    if(lay0<=nlast[k] || lay1<=nlast[k]){
      
      if(lay1>=lay0){
         inc= 1;
         lay1=min(lay1,nlast[k]);
         dir=DOWN;
      }else{
         inc=-1;
         lay0=min(lay0,nlast[k]);
         dir=UP;
      }
      
      l=lay0;
#if PRINT
      printf("lay0=%5d lay1=%5d\n",lay0,lay1);
#endif
      while(1){
         if(++npath>NMAX)errormessage(14);
         if(dir==UP)delta+=delt[k][l];
         if(region==MOHOSURF){
            if(r[l]==rmoho){
               if(      (r[l+1]==rmoho && dir==DOWN)||(r[l+1]==rmoho && dir==UP)){           /* top    */
                  fac[npath]=-sqrt(u[k][l]*u[k][l]-para*para)/rmoho;
               }else if((r[l-1]==rmoho && dir==DOWN)||(r[l-1]==rmoho && dir==UP)){           /* bottom */
                  fac[npath]= sqrt(u[k][l]*u[k][l]-para*para)/rmoho;
               }else{
                  printf("wrong!!!\n");
               }
            }else{
               fac[npath]=0.0;
            }
         }else{
            fac[npath]=-u[k][l]*u[k][l]/para;
         }
         theta[npath]=delta;
         radius[npath]=r[l];
	   vp[npath]=u[1][l];
	   vs[npath]=u[2][l];
         if(dir==DOWN)delta+=delt[k][l];
         if(l==lay1)break;
         l+=inc;
      }
      
      if(nlast[k]<=lay1 && ray.layer[i][4]==TURNING && dir==DOWN){
         if(++npath>NMAX)errormessage(14);
         uu=u[k][l];
         rr=r[l+1]+(r[l]-r[l+1])*(para-u[k][l+1])/(uu-u[k][l+1]);
         radius[npath]=rr;
         theta[npath]=delta;
	   vp[npath]=u[1][l];
	   vs[npath]=u[2][l];
/*
         printf("ray parameter = %f\n", para);
*/
         if(region==MOHOSURF)fac[npath]=0.0;
         else                fac[npath]=-para;

         if(diff==1){
            for(d=0.0;d<=dd;d+=1.0*RAD){
                if(++npath>NMAX)errormessage(14);
                theta[npath]=delta+d;
                radius[npath]=rr;
		    vp[npath]=u[1][l];
		    vs[npath]=u[2][l];
                if(region==MOHOSURF)fac[npath]=0.0;
                else                fac[npath]=-para;
            }
            delta+=dd;
         }
      }
/*      if(nlast[k]<=lay1 && ray.layer[i][4]==THROUGH){
         printf("test through\n");
      } */
    }
  }
  
  *nn=npath;

}

/*
 * uses Gauss-Legendre 10-point integration to evaluate
 * integrals k_I_n of Dziewonski, 1984
 */
void KINint(i1,i2,ray,sum,kmax,lmax,region,ker)
int i1,i2,kmax,lmax,region,ker;
double **sum;
RAY      ray;
{
static double x[]={0.0,0.1488743389,0.4333953941,
		0.6794095682,0.8650633666,0.97390652};
static double w[]={0.0,0.2955242247,0.2692667193,
		0.2190863625,0.1494513491,0.06667134};
double *theta,*r,*y2,**qrad,**qrker,*fac,*fac1;
double xm,xr,dx,xmpdx,xmmdx,rp,rm,h,xx,yy,vsvp;
double f1p,f1m,f1f2p,f1f2m,*funcp,*funcm,vs2vp2;
double cp,sp,cm,sm,cpth,cmth,spth,smth,temp,*vp,*vs;
int i,j,k,l,m,n,kmax0;
FILE *fp;
char s[132];

   
   for(k=0;k<=kmax;k++)
      for(l=1;l<=2*lmax+1;l++)sum[k][l]=0.0;
   theta=&ray.theta[i1-1];
   r    =&ray.radius[i1-1];
   vp   =&ray.vp[i1-1];
   vs   =&ray.vs[i1-1];
   n=i2-i1+1;
   if(ker==OTHERKER){
      fac  =&ray.fac[i1-1];
   }else if(ker==MUKER_P){		/* mu/rho kernel for P wave	*/
      fac  =&ray.tmp[i1-1];
      fac1 =&ray.fac[i1-1];		/* do not alter ray.fac		*/
      for(i=1;i<=n;i++){
          vsvp=(vs[i]==0.0)?0.0:vp[i]/vs[i];	/* vs[i]=r/Vs, vp[i]=r/Vp */
          fac[i]=2.0/3.0*vsvp*vsvp*fac1[i];
      }
   }else if(ker==KAPPAKER_P){		/* kappa/rho kernel for P wave */
      fac =&ray.tmp[i1-1];
      fac1=&ray.fac[i1-1];		/* do not alter ray.fac		*/
      for(i=1;i<=n;i++){
          vsvp=(vs[i]==0.0)?0.0:vp[i]/vs[i];		/* save in ray.vp and ray.vs  */
          fac[i]=(0.5-2.0/3.0*vsvp*vsvp)*fac1[i];
      }
   }
   fp = fopen("raypath.dat", "w");
   for(i=1;i<=n;i++){
/*
       fprintf(fp, "%e %e\n",theta[i]/RAD,r[i]); 
       fprintf(fp, "%8.6f %8.6f %8.6f\n",r[i],theta[i],fac[i]);
*/
     /*  xx=r[i]*cos(theta[i]);
       yy=r[i]*sin(theta[i]);
       printf("%12.4f %12.4f\n",xx,yy); */
   }
   fclose(fp);
   fp = fopen("rp.dat", "w");
/*
 * cubic spline 
 */   
   qrad  = dmatrix(1,n,1,3);
   qrker = dmatrix(1,n,1,3);
   kmax0 = max(kmax,2);
   funcp=dvector(0,kmax0);
   funcm=dvector(0,kmax0);
   drspln(1,n,theta,r,qrad);        /* cubic spline   */
   drspln(1,n,theta,fac,qrker);
   for(i=1;i<n;i++){                /* do integration */
      xm=0.5*(theta[i+1]+theta[i]);
      xr=0.5*(theta[i+1]-theta[i]);
      for(j=1;j<=5;j++){
          dx=xr*x[j];
          xmpdx=xm+dx;
          xmmdx=xm-dx;
          f1p=drsple(1,n,theta,fac,qrker,xmpdx);
/*
 	fprintf(fp,"%15.6f %15.6f\n",xmpdx, f1p);
*/
          f1p=f1p*xr;
          f1m=drsple(1,n,theta,fac,qrker,xmmdx)*xr;
          rp=drsple(1,n,theta,r,qrad,xmpdx);
          rm=drsple(1,n,theta,r,qrad,xmmdx);
          radfun(rp,funcp,region,kmax); 
          radfun(rm,funcm,region,kmax); 
          
          cp=cos(xmpdx);
          sp=sin(xmpdx);
          cm=cos(xmmdx);
          sm=sin(xmmdx);
          cpth=cmth=1.0;
          spth=smth=0.0;
          for(m=1;m<=lmax+1;m++){
              for(k=0;k<=kmax;k++){
                  f1f2p=f1p*funcp[k];
                  f1f2m=f1m*funcm[k];
/*
                  f1f2p=f1p*1.0;
                  f1f2m=f1m*1.0;
*/
                  if(m==1){
                     sum[k][1]+=w[j]*(f1f2p+f1f2m);
#if PRINT
                     printf("%4d%4d%4d%4d%12.4e%12.4e\n",i,j,m,k+1,f1f2p,f1f2m);
#endif
                  }else{
                     sum[k][2*m-2]+=w[j]*(f1f2p*cpth+f1f2m*cmth);
                     sum[k][2*m-1]+=w[j]*(f1f2p*spth+f1f2m*smth);
#if PRINT
                     printf("%4d%4d%4d%4d%12.4e%12.4e\n",i,j,m,k+1,f1f2p,f1f2m); 
#endif
                  }
              }
              temp=cpth*cp-spth*sp;
              spth=spth*cp+cpth*sp;
              cpth=temp;
              temp=cmth*cm-smth*sm;
              smth=smth*cm+cmth*sm;
              cmth=temp;
          }
      }
/*
      printf(fp, "%f %f\n", xm*180.0/3.1415926, sum[1][1]); 
*/
   }
   printf("integral of derivative = %f\n", sum[1][1]);
   free_dmatrix(qrad,1,n,1,3);
   free_dmatrix(qrker,1,n,1,3);
   free_dvector(funcp,0,kmax0);
   free_dvector(funcm,0,kmax0);
}


/*
 * computes cubic spline interpolation coefficients for y(x) between grid
 * points i1 and i2 saving them in q.  The interpolation is continuous with
 * continuous first and second derivatives.  It agrees exactly with y at
 * grid points and with the three point first derivitives at both end points
 * (i1 and i2). x must be monotonic but if two successive values of x are equal
 * a discontinuity is assumed and separate interpolation is done on each
 * strictly monotonic segment.  The arrays must be dimensioned at least - x(i2),
 * y(i2), q(3,i2), and f(3,i2).  f is working storage
 */
void drspln(i1,i2,x,y,q)
int i1,i2;
double *x,*y,**q;
{
int i,j,l,k,j1,j2,m,n;
double y0,h,h2,b0,b1,a0,ha,h2a,h2b,h3a;
double **f;  
 
 m=i2-i1+1;               /* total   
 if(m<2)errormessage(15); /* bail out if there are less than two points total. */
 f = dmatrix(1,m,1,3);
  
 j1=i1;
  
 for(i=i1;i<=i2;i++)
     if(i==i2||x[i]==x[i+1]){   /* find discontinuity, do spline interpolation     */
        j2=i;                   /* from j1 to j2 */
        n=j2-j1+1;              /* number of points */
        if(n==2){               /* there are only two points, linear interpolation */
           q[j1][1]=q[j2][1]=(y[j2]-y[j1])/(x[j2]-x[j1]);
           q[j1][2]=q[j2][2]=q[j1][3]=q[j2][3]=0.0;
        }else if(n>2){
           h =x[j1+1]-x[j1];
           h2=x[j1+2]-x[j1];
           y0=h*h2*(h2-h);
           h=h*h;
           h2=h2*h2;
           b1=b0=(y[j1]*(h-h2)+y[j1+1]*h2-y[j1+2]*h)/y0;  /* derivative at near end */
           
           a0=0.0;
      
           for(k=j1;k<=j2-2;k++){       /*explicitly reduce banded matrix to */
               h=x[k+1]-x[k];           /*           an upper banded matrix. */
               y0=y[k+1]-y[k];
               h2=h*h;
               ha=h-a0;
               h2a=h-2.0*a0;
               h3a=2.0*h-3.0*a0;
               h2b=h2*b0;
               q[k][1]=h2/ha;
               q[k][2]=-ha/(h2a*h2);
               q[k][3]=-h*h2a/h3a;
               f[k][1]=(y0-h*b0)/(h*ha);
               f[k][2]=(h2b-y0*(2.0*h-a0))/(h*h2*h2a);
               f[k][3]=-(h2b-3.0*y0*ha)/(h*h3a);
               a0=q[k][3];
               b0=f[k][3];
           }
           
           h =x[j2]-x[j2-1];     /* take care of last two rows. */
           y0=y[j2]-y[j2-1];
           h2=h*h;
           ha=h-a0;
           h2a=h*ha;
           h2b=h2*b0-y0*(2.0*h-a0);
           q[j2-1][1]=h2/ha;
           f[j2-1][1]=(y0-h*b0)/h2a;
           ha=x[j2-2]-x[j2];
           y0=-h*ha*(ha+h);
           ha=ha*ha;
           
           y0=(y[j2]*(h2-ha)+y[j2-1]*ha-y[j2-2]*h2)/y0;   /* derivative at far end */
           q[j2-1][3]=(y0*h2a+h2b)/(h*h2*(h-2.0*a0));
           q[j2-1][2]=f[j2-1][1]-q[j2-1][1]*q[j2-1][3];
        
           j=j2-1;
           for(l=j1;l<=j2-2;l++){   /* solve upper banded matrix by reverse iteration. */
               k=j-1;
               q[j][1]=f[k][3]-q[k][3]*q[j][2];
               q[k][3]=f[k][2]-q[k][2]*q[j][1];
               q[k][2]=f[k][1]-q[k][1]*q[k][3];
               j=k;
            }
           q[j][1]=b1;
           q[j2][1]=y0;
           q[j2][2]=q[j2][3]=0.0;
         }else{
             errormessage(16); 
         }
         j1=j2+1;                 /* ready for the next one */
     }
     
     free_dmatrix(f,1,m,1,3);
}

/*
 *   rsple returns the value of the function y(x) evaluated at point s
 *   using the cubic spline coefficients computed by rspln and saved in
 *   q. assuming x[1]<=x[2] ... <=x[n]. If s is outside the interval 
 *   (x[i1],x[i2]) rsple extrapolates
 *   using the first or last interpolation polynomial.  the arrays must
 *   be dimensioned at least - x[i2], y[i2], and q[i2][3].
 */
double drsple(i1,i2,x,y,q,s)
int i1,i2;
double *x,*y,**q,s;
{
static int i=1;
double h;
int ii;

   ii=i2-1;
   i=max(i,i1);              /* guarantee i within bounds. */
   i=min(i,ii);

   if     (s<x[i1])i=i1;
   else if(s>x[i2])i=ii;
   else{
      while(s>=x[i+1])++i;
      while(s< x[i]  )--i;
   }
                 
   h=s-x[i];
   return y[i]+h*(q[i][1]+h*(q[i][2]+h*q[i][3]));
}

void radfun(r,f,region,kmax)
int region,kmax;
double r,*f;
{
double u,rtop,rbot;
int i;

   if        (region==LOWERMANTLE){
      rtop=R670;
      rbot=RCMB;
   } else if (region==UPPERMANTLE){
      rtop=RMOHO;
      rbot=R670;
   } else if (region==WHOLEMANTLE){
      rtop=RMOHO;
      rbot=RCMB;
   } else if (region==INNERCORE){
      rtop=RICB;
      rbot=0.0;
   }
   if(r>rtop || r<rbot){
      for(i=0;i<=kmax;i++)f[i]=0.0;
      return;
   }
   
   if(region!=INNERCORE){
      u = (r+r-rtop-rbot)/(rtop-rbot);
   }else{
      u = r/rtop;
   }
   
   DChebyFun(u,kmax,f);
   
   if(region==INNERCORE){
      for(i=1;i<=kmax;i+=2)f[i]=0.0; /* odd k is not used to */
   }                                 /* guarantee smoothness at center */

}
void DChebyFun(x,kmax,f)
int kmax;
double x,*f;
{
double twox;
static double cheby_coef[14]={
    0.70710678118655, 1.2247448713916, 1.0350983390135, 1.0145993123918,
    1.00803225754840, 1.0050890913907, 1.0035149493262, 1.0025740068320,
    1.00196657023780, 1.0015515913133, 1.0012554932754, 1.0010368069141,
    1.00087070107920, 1.0007415648034};
int i;

   if(kmax>13)errormessage(17);
   
   f[0] = 1.0;
   f[1] = x;
   twox = 2.0*x;
   for(i=2;i<=kmax;i++)
       f[i] =  twox*f[i-1]-f[i-2];
   for(i=0;i<=kmax;i++)
       f[i]*=cheby_coef[i];

}

void ChooseTabRad(kmax,lmax,region,choice)
int *kmax,*lmax,*region;
int *choice;
{

    printf("______________________________________________________\n");
    printf("| 1 --- Whole mantle Chebyshev polynomial (P or S)	|\n");
    printf("| 2 --- Outer core   Chebyshev polynomial			|\n");
    printf("| 3 --- Inner core   Chebyshev polynomial			|\n");
    printf("| 4 --- Moho surface perturbation				|\n");
    printf("| 5 --- Whole mantle Cheby (kappa/rho, mu/rho) for P	|\n");
    printf("| 6 --- Upper mantle Chebyshev polynomial (P or S)	|\n");
    printf("| 7 --- Lower mantle Chebyshev polynomial (P or S)	|\n");
    printf("______________________________________________________\n");
    
    scanf("%d",choice);
    
    if(*choice==1 || *choice==5)*region=WHOLEMANTLE;
    else if(*choice==2){
       *region=OUTERCORE;
       printf("not complete yet\n");
       exit(1);
    }else if(*choice==3){
       *region=INNERCORE;
    }else if(*choice==4){
       *region=MOHOSURF;
    }else if(*choice==6){
       *region=UPPERMANTLE;
    }else if(*choice==7){
       *region=LOWERMANTLE;
    }
    
    if(*choice==4){
       printf("angular degree\n");
       scanf("%d",lmax);
       *kmax=0;
       printf("lmax=%d\n",*lmax);
    }else{
       printf("Radial order and angular degree\n");
       scanf("%d %d",kmax,lmax);
       printf("kmax=%d\nlmax=%d\n",*kmax,*lmax);
    }
}   

void KINintMoho(i1,i2,ray,sum,lmax)
int i1,i2,lmax;
double **sum;
RAY      ray;
{
double *theta,*r,*fac;
double cp,sp,cpth,spth,temp;
int i,j,l,m,n;

   for(l=1;l<=2*lmax+1;l++)sum[0][l]=0.0;

   theta=&ray.theta[i1-1];
   r    =&ray.radius[i1-1];
   fac  =&ray.fac[i1-1];
   n=i2-i1+1;
#if PRINT
   printf("in KIN i1=%d i2=%d\n",i1,i2);
   for(i=1;i<=n;i++){
       if(fabs(fac[i])>=1.0e-6)printf("%4d %12.4f %12.4f %12.4f\n",i,theta[i]/RAD,r[i],fac[i]); 
   }
#endif

   
   for(i=1;i<=n;i++){                /* do integration */
      if(fac[i]!=0.0){
          cp=cos(theta[i]);
          sp=sin(theta[i]);
          cpth=1.0;
          spth=0.0;
          for(m=1;m<=lmax+1;m++){
                  if(m==1){
                     sum[0][1]+=fac[i];
#if PRINT
                     printf("%4d%4d%12.4e\n",i,m-1,fac[i]);
#endif
                  }else{
                     sum[0][2*m-2]+=fac[i]*cpth;
                     sum[0][2*m-1]+=fac[i]*spth;
#if PRINT
                     printf("%4d%4d%12.4e%12.4e%12.4e\n",i,m-1,fac[i],cpth,spth); 
#endif
                 }
              temp=cpth*cp-spth*sp;
              spth=spth*cp+cpth*sp;
              cpth=temp;
          }
      }
    }
}
