#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <fcntl.h>
#include <unistd.h>
#include <limits.h>
#include <assert.h>
#include "ttimelib.h"

// this are the io routines and options for the A matrix

void PrintMenu() 
{
      cout << endl<<endl;
      cout << "Options (order doesn't matter): " << endl;
      cout << "e.g, ttime_amat_split W S (calculate A matrix for split global model)" << endl;
      cout << "---------------------------------------------------------------------------" << endl;
      cout << "W (default)           --Whole mantle model (W) as default" << endl;
      cout << "R                     --Regional model (R)" << endl;
      cout << "C (default)           --Continuous model across 670" << endl;
      cout << "S               	     --Split model across 670" << endl;
      cout << "M               	     --Multiply Split model" << endl;
      cout << "D rec1 rec2           --Read record from rec1 to rec2 (default 1--1000000)" << endl;
      cout << "---------------------------------------------------------------------------" << endl;
      cout << endl << endl;
}

void CheckMenu(int argc, char *argv[], char &model, int &begrec, int &endrec, char &modeltype)
{
// This checks the menu options
    void PrintMenu();
      if(argc==1) {  // use default values
	 model = 'W';
	 modeltype = 'C';
	 modeltype = 'M';
	 begrec = 1;
	 endrec = 1000000;
      } else {
	 PrintMenu();
      }
}

void ChooseFormat(int &amatopt, int hpts, int maxk, int &num3d, int &num2d,int &numx)
{
   cout << "Output format : " << endl;
   cout << "---------------------------------------------- " << endl;
   cout << "1. OLD FORMAT A Mat for 3-D inversion " << endl;
   cout << "2. NEW FORMAT A Mat for 3-D inversion " << endl;
   cout << "3. Joint A Mat for 1 layer of topography" << endl;
   cout << "4. Joint A Mat for 2 layers of topography" << endl;
   cout << "---------------------------------------------- " << endl;
   cout << "Enter: " << endl;
   cin >> amatopt;
   num2d = 0;
   num3d = hpts*(maxk+1);
   if(amatopt < 3) {
      numx = num3d;
   } else if(amatopt == 3) {
      num2d = hpts;
      numx=num3d+num2d;      // 3D + 1 layer of 2D B-splines
   } else {
      num2d = hpts+hpts;
      numx=num3d+num2d; // 3D + 2 layers of 2D B-splines
   }
   if(numx>SHRT_MAX){
      cerr<<"Number of unknowns exceed limit\n";
      cerr<<"Can not use irow as short integer to save matrix A element index\n";
      cerr<<"Change irow to int instead\n";
      exit(-1);
   }
}

void ChooseDelRange(int &Delopt, real &delow, real &delup)
{
   real temp;
   
   Delopt = 0;
   delow = 0.0;
   delup = 0.0;
   cout << endl;
   cout << "Set limits on epicentral distance? (0=no; 1=yes)" << endl;
   cin >> Delopt;
   if(Delopt != 0 && Delopt != 1) {
      cerr << "Delta range option not valid!!!" << endl;
      exit(-1);
   }
   if(Delopt == 1) {
      cout << "Enter desired delta range (min, max): " << endl;
      cin >> delow >> delup;
      if(delup < delow) {
         temp = delow;
         delow = delup;
         delup = temp;
      }
   }
}
