c
c  The following subroutines are used for simple xmgr plotting,
c  written by Jeff Gu, Dec, 2002.
c
c
	subroutine mktitle(infile1,xmin, xmax, ymin, ymax, wxl,wxh,
     %  wyh,sc,ifl, title)
	real xmin, xmax,ymin, ymax, sc
	real wxl, wxh,wyh
	integer xtkmajor, xtkminor
	integer ifl
	character*50 infile1
	character*50 title
	write(22,"('with g', i1)")ifl
	write(22,"('g',i1,' on')")ifl
	write(22,"('g',i1,' hidden false')")ifl
	write(22,"('g',i1,' type xy')")ifl
	write(22, "('yaxis off')")
 	write(22, "('xaxis tick op bottom')")
	write(22,"('xaxis tick minor size 0')")
       write(22,"('s0 linestyle 1')")
       write(22,"('s0 linewidth 1')")
       write(22,"('s0 color 1')")
       write(22,"('auto redraw on')")
       write(22,"('view xmin ',f5.2)") xmin
       write(22,"('view xmax ',f5.2)") xmax
       write(22,"('view ymin ',f5.2)") ymin
       write(22,"('view ymax ',f5.2)") ymax
       write(22,"('world xmin ',e10.4)")wxl
       write(22,"('world xmax ',e10.4)")wxh
       write(22,"('world ymin ',e10.4)")-wyh
       write(22,"('world ymax ',e10.4)")wyh
       xtkmajor=ifix((wxh-wxl)/10.0)
       xtkminor=xtkmajor/2
       write(22,"('xaxis  tick on')")
       write(22,"('xaxis  tick major ',i8)")xtkmajor
       write(22,"('xaxis  tick minor ',i8)")xtkminor
       write(22,"('xaxis  tick major linewidth ',f5.2)")sc
       write(22,"('xaxis  tick minor linewidth ',f5.2)")sc
       write(22,"('xaxis ticklabel on')")
       write(22,"('xaxis ticklabel char size ', f5.2)")sc
       write(22,"('xaxis ticklabel font 4')")
       write(22,"('yaxis tick log off ')")
       write(22,"('yaxis ticklabel on')")
       write(22,"('yaxis label layout perp')")
       write(22,"('yaxis label char size 1.000')")
       write(22,"('yaxis label \"TRANSVERSE\"')")
       write(22,"('yaxis ticklabel char size ', f5.2)")sc
       write(22,"('yaxis ticklabel font 4')")
       write(22,"('yaxis ticklabel linewidth ',f5.2)")sc
       write(22,"('yaxis tick spec 0')")
       write(22,"('subtitle \"', a,'\"')")title(1:lnblnk(title))
       write(22,"('subtitle font 0')")
       write(22,"('subtitle size 1.000')")
       write(22,"('subtitle color 1')")
       write(22,"('subtitle linewidth 1')")
       write(22,"('read block \"',a,'\"')")infile1(1:lnblnk(infile1))
       write(22,"('block xy \"1:2\"')")
       return
       end

       subroutine addstring_xmgr(ifid, strloc1, strloc2, str)
c
c  print a text string in a graph
c
       integer ifid
       real strloc1, strloc2
       character str*(*)
       write(ifid, "('with string')")
       write(ifid, "('string on')")
       write(ifid, "('string loctype view')")
       write(ifid, "('string ', f6.3,',', f6.3)") strloc1, strloc2
       write(ifid, "('string linewidth 2')")
       write(ifid, "('string color 1')")
       write(ifid, "('string rot 0')")
       write(ifid, "('string font 4')")
       write(ifid, "('string just 0')")
       write(ifid, "('string char size 0.8')")
       write(ifid, "('string def \"', a, '\"')") str(1:lnblnk(str))
       return
       end

       subroutine tick_spacing(xl, xh, nseg, scale)
c
c  finds tick spacing, a very rough scheme
c
       real xl, xh, dx
       real xxl, xxh
       real xxxl, xxxh, dxxx
       integer nseg, i
       dx=abs((xh-xl)/nseg)
       xxl=1.0e-20
       xxh=1.0e-19
       scale=1.0e19
       do i=1, 44
		if(dx.ge.xxl.and.dx.lt.xxh) then
			xxxl=xxl
			dxxx=(xxh-xxl)/9.0
			xxxh=dxxx+xxxl
			do j=1, 10
				if(xxxl.le.dx.and.xxxh.gt.dx) then
					scale=xxxh
					goto 100
				endif
				xxxl=xxxl+dxxx
				xxxh=xxxh+dxxx
			enddo
		endif
		xxl=xxl*10.0
		xxh=xxh*10.0
       enddo
100    print*, 'tick mark spacing =', scale
       return
       end

       subroutine makebatch(ifid,infl,sta,del,xmin, xmax, ymin,ymax,
     %		wxl,wxh,wyh,sc,ifl,il,infl2, imd)
c  This is a drawing subroutine using xvgr.  It creates a batch file.
c  INPUT:
c	ifid : file id
c	infl : Input file name (also could be 1 of 2 input files)
c	sta  : a string before each trace(station, sta, etc)		
c	del  : Epicentral distance before each trace, could also 
c            be used for sta values.
c      xmin  : Minimum x view value 
c	xmax : Maximum x view value
c	ymin : Minimum y view value
c      ymax  : Maximum y view value
c	wxl  : Minimum value for x world
c      wxh   : Maximum value for x world
c 	wyh  : Absolute Maximum of y values
c      sc    : Scaling factor for ploting, it should be slightly bigger than 
c             the maximum y value
c  	ifl  : The present number of trace
c      il    : see if it is the last trace to be plotted
c      infl2 : File name of the second file (synthetic, etc), not considered
c             if imd is 1
c      imd   : imd=1(plot 1), imd=2(plot 2 together)

c
      real xmin, xmax,ymin, ymax, sc
      real wxl, wxh,wyh,del
      real xtkmajor, xtkminor
      integer imd, ifid
      integer ifl, il, igraph
      character sta*(*)
      character infl*(*)
      character infl2*(*)  !infl2 can be arbitrary if imd=1
      character*128 title, xlabel
      igraph = ifl-1
      if(igraph.lt.10) then
         write(ifid,"('with g', i1)")igraph
         write(ifid,"('g',i1,' on')")igraph
         write(ifid,"('g',i1,' hidden false')")igraph
         write(ifid,"('g',i1,' type xy')")igraph
      else
         write(ifid,"('with g', i2)")igraph
         write(ifid,"('g',i2,' on')")igraph
         write(ifid,"('g',i2,' hidden false')")igraph
         write(ifid,"('g',i2,' type xy')")igraph
      endif
      write(ifid,"('auto redraw on')")
      write(ifid, "('xaxis tick op bottom')")
      write(ifid, "('xaxis ticklabel prec 0')")
      write(ifid,"('xaxis tick minor size 0')")
      write(ifid,"('s0 linestyle 1')")
      write(ifid,"('s0 linewidth 2')")
      write(ifid,"('s0 color 1')")
      if(imd.eq.2) then
         write(ifid,"('s1 linestyle 2')")
         write(ifid,"('s1 linewidth 2')")
         write(ifid,"('s1 color 2')")
      endif
      write(ifid,"('view xmin ',f5.2)") xmin
      write(ifid,"('view xmax ',f5.2)") xmax
      write(ifid,"('view ymin ',f5.2)") ymin
      write(ifid,"('view ymax ',f5.2)") ymax
      write(ifid,"('world xmin',e15.4)") wxl 
      write(ifid,"('world ymin',e15.4)") -wyh
      write(ifid,"('world xmax',e15.4)") wxh 
      write(ifid,"('world ymax',e15.4)") wyh
      write(ifid,"('yaxis ticklabel on')")
      write(ifid,"('yaxis ticklabel type spec')")
      write(ifid,"('yaxis tick type spec')")
      write(ifid,"('yaxis ticklabel prec 6')")
      write(ifid,"('yaxis label layout perp')")
      write(ifid,"('yaxis label char size 0.8')")
      write(ifid,"('yaxis label font 1')")
      write(ifid,"('yaxis label \"',i3,'   ',a4, f5.1,' ','\"')")
     %        ifl,  sta(1:lnblnk(sta)),del

      if(igraph.eq.0) then
         write(ifid,"('xaxis tick on')")
         write(ifid,"('xaxis ticklabel on')")
         write(ifid,"('xaxis ticklabel char size 1.0000')")
         write(ifid,"('xaxis ticklabel font 0')")
         write(ifid,"('xaxis bar on')")
         write(ifid,"('xaxis tick major size 0.8')")
         write(ifid,"('xaxis tick minor size 0.6')")
	 call tick_spacing(wxl, wxh, 5, xtkmajor)
         write(ifid,"('xaxis  tick major ',f8.2)")xtkmajor
         write(ifid,"('xaxis  tick minor ',f8.2)")xtkmajor
         write(ifid,"('xaxis ticklabel prec 1')")
         write(ifid,"('xaxis ticklabel char size 1.000')")
         write(ifid,"('xaxis ticklabel font 0')")
         write(ifid,"('xaxis label \"time (sec)\"')")
         write(ifid,"('xaxis label font 0')")
         write(ifid,"('xaxis label char size 1.0')")
      else
         write(ifid,"('xaxis tick off')")
         write(ifid,"('xaxis ticklabel off')")
      endif
      if(il.eq.1) then
          write(ifid,"('with string')")
          write(ifid,"('string on')")
          write(*,*) 'title -->'
          read(*,"(a)") title
	  write(ifid, "('subtitle \"', a, '\"')") title(1:lnblnk(title))
          write(ifid,"('subtitle font 1')")
          write(ifid,"('subtitle size 1.200000')")
          write(ifid,"('subtitle color 1')")
          write(ifid,"('subtitle linewidth 1')")
          write(ifid,"('with string')")
          write(ifid,"('string on')")
          write(ifid,"('string 0.05, 0.45')")
          write(ifid,"('string linewidth 1')")
          write(ifid,"('string color 1')")
          write(ifid,"('string rot 90')")
          write(ifid,"('string font 0')")
          write(ifid,"('string just 2')")
          write(ifid,"('string char size 1.0')")
	  print*, 'enter x-axis label:'
	  read(*,"(a)") xlabel
          write(ifid,"('string def \"', a, '\"')") 
     +			xlabel(1:lnblnk(xlabel))
      endif
      write(ifid,"('frame off')")
      if(ifl.ne.0) then
         write(ifid,"('read block \"',a,'\"')")infl(1:lnblnk(infl))
         write(ifid,"('block xy \"1:2\"')")
         if(imd.eq.2) then
            write(ifid,"('read block \"',a,'\"')")infl2(1:lnblnk(infl2))
            write(ifid,"('block xy \"1:2\"')")
         endif
      endif
      return
      end

	subroutine plottrace(twofl, idefault)
c  this is a program that will display the result of a number of traces
c  on a single plot.  It is an experiment with xvgr plotting.
	implicit real(a-h, o-z)
	parameter (twopi = 6.283185307)
	parameter (idat=4000)
	parameter (igraftotal=100)
	integer  nfl
	character*256 systemstring
	integer system,idefault
	character*(*) twofl(2)
	character*128 titlename
	real scale, xx, yy, datmax, datmin
	real xmin, xmax, ymin, ymax,dy,wxmin, wxmax, wymax,dspace
	nfl=2
	dy = 0.66/float(nfl)
	dspace=0.33/float(nfl)
	ymin=0.07
	xmin=0.07
	xmax=0.95
	ymin0=ymin
	scale=1.5/float(nfl)
	print*, 'scale is :', scale
       open(22, file='batch.xvgr', status='unknown')
       write(22,"('auto redraw off')")
	do i=1, nfl
	    ymax=ymin+dy
           datmax=0.0
           datmin=9999.0
           open(i, file=twofl(i)(1:lnblnk(twofl(i))), status='old')
           j=1
5	    read(i,*,end=9) xx, yy
  	     if(abs(yy).gt.datmax) then
	    	 datmax=abs(yy)
	     endif
	    if(j.eq.1) wxmin=xx !first xx value
	    j=j+1
	    goto 5
9	    wxmax=xx !last xx value
	    print*,wxmin, wxmax
	    wymax=datmax
	    print*, -wymax, wymax
	    if(i.eq.1) then
	       if(idefault.eq.1) then
	    	    titlename='DATA SEISMOGRAM (4 sec/sample)'
	    	endif
	    	if(idefault.eq.2) then
	    	    titlename='DATA SEISMOGRAM (1 sec/sample)'
	    	endif
	    	if(idefault.eq.3) then
	    	    titlename='CROSS-CORRELATION FUNCTION (DATA)'
	    	endif
	    else
	       if(idefault.eq.1) then
	           titlename='SYNTHETIC SEISMOGRAM (4 sec/sample)'
	       endif
	       if(idefault.eq.2) then
	           titlename='SYNTHETIC SEISMOGRAM (1 sec/sample)'
	       endif
	    	if(idefault.eq.3) then
	    	    titlename='CROSS-CORRELATION FUNCTION (SYNTHETIC)'
	    	endif
	    endif  
	    close(i) 
           call mktitle(twofl(i),xmin, xmax, ymin,
     %        ymax,wxmin,wxmax,wymax, scale,i-1, titlename)
     	    write(22,"('auto redraw on')")
	    ymin= ymax+dspace
	enddo
	close(22)
	 systemstring='xvgr -maxgraph 100 -batch batch.xvgr'
        ierr=system(systemstring)
	end
